package me.Prometheus.DeGriefer;

import java.io.IOException;

import me.Prometheus.DeGriefer.DeGriefer;

import org.bukkit.event.Listener;
import org.bukkit.event.EventHandler;
import org.bukkit.event.EventPriority;
import org.bukkit.event.block.BlockBreakEvent;
import org.bukkit.event.block.BlockPlaceEvent;

public class DeGrieferListener implements Listener
{
	public static DeGriefer plugin;
	
	public DeGrieferListener(DeGriefer instance)
	{
		plugin = instance;
	}
	
	private boolean pluginOn(String wName)
	{
		if(plugin.dataStore.read(wName) == null)
		{
			plugin.dataStore.write(wName, "true");
			return true;
		}
		else
		{
			if(plugin.dataStore.read(wName) == "true")
			{
				return true;
			}
			else
			{
				return false;
			}
		}
	}
	
	@EventHandler(priority = EventPriority.HIGH)
	public void onBlockPlace(BlockPlaceEvent e)
	{
		if(pluginOn(e.getBlock().getWorld().getName()))
		{
			String blockX = String.valueOf(e.getBlock().getX());
			String blockY = String.valueOf(e.getBlock().getY());
			String blockZ = String.valueOf(e.getBlock().getZ());
			String blockW = String.valueOf(e.getBlock().getWorld().getName());
			String uID = blockW+","+blockX+","+blockY+","+blockZ;
			//Creates a unique string ID for each block.
			if(plugin.DataWorker.getBoolean("WhiteList"))
			{	
				String pPlayer;
				for(int i = 0; i > plugin.dgPlayerList.size(); i++)
				{
					pPlayer = plugin.dgPlayerList.get(i);
					if(e.getPlayer().getName().equalsIgnoreCase(pPlayer))
					{
						plugin.dataStore.write(uID, e.getPlayer().getName().toLowerCase());
					}
				}
			}
			else
			{
				plugin.dataStore.write(uID, e.getPlayer().getName().toLowerCase());
				try
				{
					plugin.dataStore.persist();
				}
				catch (IOException e1)
				{
					plugin.logger.info("Dear SysAdmin, there's an error. Chances are it's because write permissions are missing.");
				}
			}
		}
	}
	
	@EventHandler(priority = EventPriority.HIGH)
	public void onBlockBreak(BlockBreakEvent e)
	{
		if(pluginOn(e.getBlock().getWorld().getName()))
		{
			String blockX = String.valueOf(e.getBlock().getX());
			String blockY = String.valueOf(e.getBlock().getY());
			String blockZ = String.valueOf(e.getBlock().getZ());
			String blockW = String.valueOf(e.getBlock().getWorld().getName());
			String uID = blockW+","+blockX+","+blockY+","+blockZ;
			if(plugin.dataStore.read(uID) != null)
			{
				if(!plugin.dataStore.read(uID).equalsIgnoreCase(e.getPlayer().getName()) || e.getPlayer().hasPermission("degriefer.cankill"))
				{
					e.setCancelled(true);
				}
			}
		}
	}
}
